Index: java/Framclipse/com.framsticks.framclipse.ui/src/com/framsticks/framclipse/ui/labeling/FramScriptLabelProvider.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse.ui/src/com/framsticks/framclipse/ui/labeling/FramScriptLabelProvider.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse.ui/src/com/framsticks/framclipse/ui/labeling/FramScriptLabelProvider.java	(revision 440)
@@ -112,3 +112,7 @@
 		return "class.gif";
 	}
+
+	public String text(EObject obj) {
+		return obj.eClass().getName();
+	}
 }
Index: java/Framclipse/com.framsticks.framclipse/res/framscontext.dtd
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscontext.dtd	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/res/framscontext.dtd	(revision 440)
@@ -6,14 +6,13 @@
 
 <!--
- framsticks files can reference scripting objects in 3 ways
- as described by the 3 tags of the framscontext.xml file:
+ Framsticks files can reference scripting objects in 3 ways
+ as described by 3 tags of the framscontext.xml file:
 
- - <objects> framsticks objects are stored in the file in the framsticks format
- - <code> a field in the file (using the framsticks format) contains a script
-         that uses some objects
+ - <objects> Framsticks objects are stored in the file in the Framsticks format
+ - <code> a field in the file (using the Framsticks format) contains a script that uses some objects
  - <script> plain text file containing a script
 
 <script> excludes the two following tags.
-<code> implies that the framsticks format is used for the file so the <objects> tags will be also used to declare which objects can be present in the file.
+<code> implies that the Framsticks format is used for the file so the <objects> tags will be also used to declare which objects can be present in the file.
 -->
 
Index: java/Framclipse/com.framsticks.framclipse/res/framscontext.xsl
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscontext.xsl	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/res/framscontext.xsl	(revision 440)
@@ -9,11 +9,19 @@
 
 <xsl:template match="framscontext">
+<style>
+.file {color:red;}
+.context-code {color: #00ee00;} 
+.context-file {color: #007700;} 
+.objects {color: #0000ff;} 
+</style>
+
   <h1>Framscript Context Configuration</h1>
-<i>Note:
+
+<b>Each <span class="file">file type</span> may contain <span class="objects">objects</span> from many <span class="context-file">contexts</span>, as specified below.<br/>Each <span class="context-file">context</span> may contain many <span class="objects">objects</span>, as specified below.<br/>Note:
   <xsl:choose><xsl:when test="count(document('framscript.xml')/framscript)=0">
-	This formatting sheet would also use <a href="framscript.xml">framscript.xml</a> to show object names if that file was available</xsl:when>
-<xsl:otherwise>This formatting sheet also includes object names extracted from <a href="framscript.xml">framscript.xml</a></xsl:otherwise>
+	This formatting sheet (xsl) would use <a href="framscript.xml">framscript.xml</a> to show object names if that file was available!</xsl:when>
+<xsl:otherwise>This formatting sheet (xsl) includes object names extracted from <a href="framscript.xml">framscript.xml</a>.</xsl:otherwise>
 	</xsl:choose>
-</i>
+</b><br/><br/><br/>
 
   <table border="1">
@@ -25,9 +33,9 @@
 <xsl:template match="file">
   <tr valign="top">
-   <td><b><xsl:value-of select="@label"/></b><br/><xsl:value-of select="@pattern"/></td>
+   <td class="file"><b><xsl:value-of select="@label"/></b><br/><xsl:value-of select="@pattern"/></td>
    <td>
 	<xsl:if test="count(code)!=0">
 	<p title="Defined by &lt;objects&gt;">
-	Objects defined in the following contexts can be stored directly in the file: (using the standard framsticks format)<ul><xsl:apply-templates select="objects"/></ul>
+	Objects defined in the following contexts can be stored directly in the file (using the standard Framsticks <a href="http://www.framsticks.com/common/formatspec.html">format</a>):<ul><xsl:apply-templates select="objects"/></ul>
 	</p>
 	<xsl:apply-templates select="code"/>
@@ -86,6 +94,21 @@
 </xsl:template>
 
+
+
+
+<xsl:template name="extobjects">
+  <xsl:param name="objs"/>
+  <xsl:if test="count($objs)!=0">
+  (
+  <xsl:for-each select="$objs">
+	<font class="objects"><xsl:value-of select="@name"/></font>,
+  </xsl:for-each>
+  )
+  </xsl:if>
+</xsl:template>
+
+
 <xsl:template match="objects">
-  <li><b><xsl:value-of select="@context"/></b>
+  <li><b><span class="context-file"><xsl:value-of select="@context"/></span></b>
 	<xsl:variable name="context" select="@context"/>
       	<xsl:call-template name="extobjects"><xsl:with-param name="objs" select="document('framscript.xml')/framscript/type[@context=$context]"/></xsl:call-template>
@@ -94,5 +117,5 @@
 
 <xsl:template match="script">
-  <li><b><xsl:value-of select="@context"/></b>
+  <li><b><span class="context-code"><xsl:value-of select="@context"/></span></b>
 	<xsl:variable name="context" select="@context"/>
       	<xsl:call-template name="extobjects"><xsl:with-param name="objs" select="document('framscript.xml')/framscript/type[@context=$context]"/></xsl:call-template>
@@ -100,21 +123,12 @@
 </xsl:template>
 
-<xsl:template name="extobjects">
-  <xsl:param name="objs"/>
-  <xsl:if test="count($objs)!=0">
-  (
-  <xsl:for-each select="$objs">
-	<xsl:value-of select="@name"/>,
-  </xsl:for-each>
-  )
-  </xsl:if>
-</xsl:template>
-
 <xsl:template match="context">
-  <li><b><xsl:value-of select="@name"/></b>
+  <li><b><span class="context-code"><xsl:value-of select="@name"/></span></b>
 	<xsl:variable name="context" select="@name"/>
       	<xsl:call-template name="extobjects"><xsl:with-param name="objs" select="document('framscript.xml')/framscript/type[@context=$context]"/></xsl:call-template>
   </li>
 </xsl:template>
+
+
 
 <xsl:template match="code">
@@ -126,5 +140,5 @@
 <xsl:template match="properties">
   <li>
-  <b><xsl:value-of select="@to"/></b> is defined by "<xsl:value-of select="@from"/>" objects
+  <span class="objects"><b><xsl:value-of select="@to"/></b></span> is defined by <span class="objects"><xsl:value-of select="@from"/></span> objects
   </li>
 </xsl:template>
Index: java/Framclipse/com.framsticks.framclipse/res/framscript.dtd
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.dtd	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.dtd	(revision 440)
@@ -11,5 +11,5 @@
 
 <!-- "type" attribute in element:
-     - framscript scalar datatypes: "integer", "float", "string"
+     - Framscript scalar datatypes: "integer", "float", "string"
      - object of unknown type: "Object"
      - value of unknown type: "untyped" (this can be object or not)
@@ -22,7 +22,13 @@
 <!ATTLIST element max CDATA #IMPLIED>
 <!ATTLIST element function (false|true) "false">
+<!ATTLIST element deprecated (false|true) "false">
 <!ATTLIST element default CDATA #IMPLIED>
 
-<!-- important difference: no <arguments> tag means the argument number is not known
+<!-- The full list of possible values for flags is defined and explained in param.h in Framsticks SDK:
+     https://www.framsticks.com/svn/framsticks/cpp/frams/param/param.h
+     Other related information can be found at http://www.framsticks.com/common/formatspec.html -->
+<!ATTLIST element flags CDATA #IMPLIED>
+
+<!-- Important difference: no <arguments> tag means the argument number is not known
                            empty <arguments> means the function does not accept arguments -->
 <!ELEMENT arguments (argument*)>
Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xsl
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xsl	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xsl	(revision 440)
@@ -10,4 +10,5 @@
 <xsl:template match="framscript">
   <h1>Framscript Objects</h1>
+  <b>These objects can be used in many <a href="framscontext.xml">contexts and files</a>.<br/><br/><br/></b>
   <xsl:apply-templates select="//framscript/type"/>
 </xsl:template>
@@ -25,5 +26,5 @@
 
 <xsl:template match="element">
-  <li><b><xsl:value-of select="@name"/></b> - 
+  <li><xsl:choose><xsl:when test="@deprecated='true'"><strike><xsl:value-of select="@name"/></strike></xsl:when><xsl:otherwise><b><xsl:value-of select="@name"/></b></xsl:otherwise></xsl:choose> - 
    <xsl:if test="@function='true'">
     function <xsl:if test="@type!=''">returning <xsl:value-of select="@type"/></xsl:if>
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScript.xtext
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScript.xtext	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScript.xtext	(revision 440)
@@ -1,3 +1,3 @@
-grammar com.framsticks.framclipse.FramScript with org.eclipse.xtext.common.Terminals
+grammar com.framsticks.framclipse.FramScript with org.eclipse.xtext.common.Terminals hidden(SL_COMMENT, ML_COMMENT, WS)
 
 import "http://www.eclipse.org/emf/2002/Ecore" as ecore
@@ -54,24 +54,26 @@
 	'prop:'
 	headers += PropertyHeader*
-	'id:' name=ID 
+	'id:' name=ID
 	headers += PropertyHeader+
 	;
-	
+
 State :
-	'state:' 
+	'state:'
 	headers += PropertyHeader*
-	'id:' name=ID 
+	'id:' name=ID
 	headers += PropertyHeader+
 	;
-	
+
 Include : {Include}
-	code=Code?
-	(properties+=Property |
-	states+=State)*
+	(
+		code=Code?
+		(properties+=Property |
+		states+=State)*
+	) | {Block} statements+=Statement+
 ;
-	
+
 Header :
-	name=ID value=HEADER_VALUE ;
-	
+	name=HEADER_ID value=HEADER_VALUE ;
+
 NeuroHeader returns Header :
 {IntHeader}		name=('prefinputs:' | 'prefoutput:' | 'preflocation:' | 'vhints:') intValue=IntValue |
@@ -79,32 +81,33 @@
 {IconHeader}	name='icon:~' icon=Icon '~' |
 				Header ;
-				
-Icon : 
+
+Icon :
 	INT (',' INT)+ ;
-	
+
 PropertyHeader returns Header :
 	TypeHeader |
 	FlagsHeader |
 	Header ;
-	
+
 ShowHeader returns Header :
-	name='expdef:' value=ID |
+	name='expdef:' importURI=ID |
 	Header ;
-	
+
 FlagsHeader returns Header :
 {IntHeader}	name='flags:' intValue=INT ;
-	
+
 TypeHeader :
-	name='type:' type=PropertyType ;
-	
+	name=TYPE_HEADER type=PropertyType ;
+
+// This terminal is defined separately for use with FramScriptAuxiliaryLexer.
+terminal TYPE_HEADER : 'type:';
+
 PropertyType :
-	name=ID (min=Number (max=Number default=Number?)? enums+=ENUM_LITERAL* )? ;
-	
-terminal ENUM_LITERAL :
-	'~' !('~'|'\r'|'\n')+ ;
-
-Number :
-	'-'? (INT | DOUBLE) ;
-	
+	name=ID (min=Number max=Number default=(Number|HEADER_VALUE)? enums+=ENUM_LITERAL* )? ;
+
+Number : IntNumber | DoubleNumber ;
+IntNumber : '-'? INT ;
+DoubleNumber : '-'? DOUBLE ;
+
 CodeSection returns Code :
 	'code:~' Code '~' ;
@@ -123,12 +126,21 @@
 IncludeDeclaration :
 	'@include' importURI=STRING ;
-	
+
+/*
+ * For some reason, the '#include' keyword is not matched.
+ * It is possible it has been overshadowed by SL_COMMENT,
+ * despite the order in which the two have been defined.
+ * This has been worked around in FramScriptAuxiliaryLexer.
+ */
 PropertyIncludeDeclaration :
-	'#include' importURI=STRING ;
-	
+	PROP_INCLUDE importURI=STRING ;
+
+// keyword separated for use in FramScriptAuxiliaryLexer
+terminal PROP_INCLUDE : '#include' ;
+
 Block :
-{Block}	'{' statements+=Statement* '}' ;
-	
-Statement :	
+	'{' statements+=Statement+ '}' ;
+
+Statement :
 	( VariableDeclarationStatement |
 	ExpressionStatement |
@@ -145,4 +157,5 @@
 	WhileStatement |
 	ForStatement |
+	ForEachStatement |
 {EmptyStatement} ';' ;
 
@@ -154,9 +167,16 @@
 	
 IfStatement :
-	'if' '(' condition=Expression ')' if=Statement ('else' else=Statement)? ;
-	
-ForStatement : 
-	'for' '(' init=Assignment? ';' condition=Expression? ';' step=Assignment? ')' body=Statement ;
-	
+	'if' '(' condition=Expression ')' if=Statement (=>'else' else=Statement)? ;
+
+ForStatement :
+	'for' '(' (init=Assignment | init=VariableDeclarationStatement)? ';' condition=Expression? ';' step=Assignment? ')' body=Statement ;
+
+ForEachStatement :
+	'for' '(' (decl=Iterator|ref=[VariableDeclaration]) 'in' colection=Expression ')' body=Statement ;
+
+Iterator returns VariableDeclaration :
+	'var' name=ID
+;
+
 WhileStatement :
 	'while' '(' condition=Expression ')' body=Statement ;
@@ -182,6 +202,6 @@
 SwitchStatement :
 	'switch' condition=ParExpression '{' labels+=SwitchGroup* '}' ;
-	
-SwitchGroup : 
+
+SwitchGroup :
 	label=SwitchLabel body=SwitchBlock ;
 	
@@ -206,62 +226,85 @@
 
 Expression :
-	UnaryExpression ({Expression.left=current} op=Operator right=Expression)? | 
+	UnaryExpression ({Expression.left=current} op=Operator right=Expression)? |
 	WildcardExpression ;
-	
-UnaryExpression  :
+
+UnaryExpression :
 	QualifiedExpression2 ({UnaryExpression.arg=current} op = IncrementOperator)? |
 	op = (IncrementOperator | UnaryOperator) arg = QualifiedExpression2 |
+	FunctionLiteral |
 	Literal ;
-	
+
 QualifiedExpression2 returns QualifiedExpression :
 	QualifiedExpression |
 	(PropertyAccess|StateAccess) ({QualifiedExpression.parent=current}'.' child=QualifiedExpression )? ;
-	
+
 QualifiedExpression :
-	ArrayElementExpression ({QualifiedExpression.parent=current}'.' child=QualifiedExpression )? ;
-	
+	MemberAccess ({QualifiedExpression.parent=current}'.' child=QualifiedExpression )? ;
+
+MemberAccess returns QualifiedExpression:
+	ArrayElementExpression ( {MemberAccess.left=current} '.[' child=Expression ']')? ;
+
 ArrayElementExpression :
 	TerminalExpression ({ArrayElementExpression.array=current} ('[' indexes+=Expression ']')+ )? ;
- 
+
 TerminalExpression:
+				Cast |
+				TypeOf |
 				Invocation |
 				Array |
-				Vector | 
+				Vector |
+				Dictionary |
 {VariableRef} 	var=[VariableDeclaration];
- 				
+
+Cast :
+	type=('int'|'float'|'string') '(' expression=Expression ')' ;
+
+TypeOf :
+	'typeof' '(' expression=Expression ')' ;
+
 Invocation :
 	function=[Function] '(' (args+=Expression (',' args+=Expression)*)? ')' ;
-	
+
 WildcardExpression :
 	value=ID '.*' ;
-	
+
 PropertyAccess returns QualifiedExpression :
-	('Fields.'|'ExpParams.'|'ShowParams.'|'VisParams.') property=[Property] ;
-	
+{PropertyAccess}	('Fields'|'ExpParams'|'ShowParams'|'VisParams') ('.*' | =>('.' property=[Property]) | '.[' (=>property=[Property|STRING] | child=Expression ) ']')? ;
+
 StateAccess returns QualifiedExpression :
-	'ExpState.' state=[State] ;
-	
+{StateAccess}	'ExpState' (".*" | =>('.' state=[State]) | '.[' (=>state=[State|STRING] | child=Expression ) ']')? ;
+
+FunctionLiteral:
+	'function' function=[Function] ;
+
 Literal:
-{IntLiteral}	value=IntValue | 
-{DoubleLiteral}	value=DoubleValue | 
-{StringLiteral}	value=STRING | 
-{HexLiteral}	value=HEX | 
+{IntLiteral}	value=IntValue |
+{DoubleLiteral}	value=DoubleValue |
+{StringLiteral}	value=STRING |
+{RawStringLiteral}	value=ML_STRING |
+{HexLiteral}	value=HEX |
 {NullLiteral}	'null' ;
 
 Array :
-	'[' elements+=Expression (',' elements+=Expression)* ']' ;
+{Array}	'[' (elements+=Expression (',' elements+=Expression)*)? ']' ;
 
 Vector  :
 	'(' elements+=Expression (',' elements+=Expression)* ')' ;
 
-Operator : 
-	'+' | '-' | '*'| '/' | 
+Dictionary :
+{Dictionary}	'{' ( keys+=DictKey values+=Expression (',' keys+=DictKey values+=Expression)* )? '}' ;
+
+DictKey :
+	STRING ':' ;
+
+Operator :
+	'+' | '-' | '*'| '/' |
 	'&'| '|' | '%' |
 	'==' | '!=' | '>=' | '<=' | '<' | '>' |
 	'&&' | '||' ;
-	
+
 UnaryOperator :
-	'!' | '+' | '-' | 'typeof';
-	
+	'!' | '+' | '-';
+
 IncrementOperator :
 	'++' | '--' ;
@@ -272,17 +315,51 @@
 DoubleValue hidden() :
 	('+'|'-')? DOUBLE ;
-	
-terminal DOUBLE : 
+
+terminal DOUBLE :
 	('0'..'9')*'.'('0'..'9')+ ('e' INT)? |
 	INT 'e' INT ;
-	
-terminal HEX : 
+
+terminal ENUM_LITERAL :
+	'~' !('~'|'\r'|'\n')+ ;
+
+terminal HEX :
 	'0x' (('0'..'9')|('a'..'f')|('A'..'F'))+ ;
-	
-terminal HEADER_VALUE : 
-	':' !('~'|' '|'\t'|'\r'|'\n') !('\n'|'\r')* ('\r'? '\n') |
-	':~' -> '~'('\r'? '\n') 
-	;
-	
-terminal SL_COMMENT : ('//' | '# ')  !('\n'|'\r')* ('\r'? '\n')?;
-
+
+terminal ML_STRING :
+	'"""' -> '"""' |
+	"'''" -> "'''"
+;
+
+terminal SL_COMMENT : ('//' | '#') -> NL ;
+
+terminal HEADER_ID :
+	(
+		'name' |
+		'longname' |
+		'description' |
+		'group' |
+		'help' |
+		'info' |
+		'neurons'
+	) ':'
+;
+
+/*
+ * This rule should not match anything,
+ * so expect an error when generating the artifacts.
+ * If it is not there, something went wrong.
+ * This rule is here just to make Xtext generate a constant
+ * to be used in a custom lexer (FramScriptAuriliaryLexer),
+ * which takes context into account,
+ * so it is able to recognise HEADER_VALUE
+ * without conflicting with Framscript code syntax.
+ * It should match the following rules,
+ * but only when preceded with HEADER_ID:
+ *	'~' NL ('\\~'|!'~')* '~' NL | -> NL,
+ * where NL is defined as: '\r' '\n'? | '\n',
+ * The final NL is not matched, but it is a part of context.
+ * This token is also emitted for the default value in PropertyType.
+ */
+terminal HEADER_VALUE : 'name:';
+
+terminal fragment NL : '\r' '\n'? | '\n' ;
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptAuxiliaryLexer.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptAuxiliaryLexer.java	(revision 440)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptAuxiliaryLexer.java	(revision 440)
@@ -0,0 +1,240 @@
+package com.framsticks.framclipse;
+
+import org.antlr.runtime.CharStream;
+import org.antlr.runtime.RecognitionException;
+import org.antlr.runtime.Token;
+
+import com.framsticks.framclipse.parser.antlr.internal.InternalFramScriptLexer;
+
+public class FramScriptAuxiliaryLexer extends InternalFramScriptLexer {
+
+	private static final int FLG_MULTILINE = 0x1;
+	private static final int FLG_TYPE_IS_NUMERIC = 0x2;	// if raised, the default value should be analysed with internal lexer
+	private static final int FLG_TYPE_IS_STRING = 0x4;	// if raised, the max value can be omitted and should be 0
+	private static final int CTX_NONE = 0;
+	private static final int CTX_TYPE = 1;
+	private static final int CTX_TYPE_ID = 2;
+	private static final int CTX_TYPE_MIN = 3;
+	private static final int CTX_TYPE_MAX = 4;
+	private static final int CTX_TYPE_DEFAULT = 5;
+
+	private int context = CTX_NONE;
+	private int flags = 0;
+	private Token previous = Token.INVALID_TOKEN;
+
+	private void checkML() {
+		setFlag(FLG_MULTILINE, next() == '~');
+	}
+
+	private boolean isSet(int flag) {
+		return (flags & flag) != 0;
+	}
+
+	private void setFlag(int flag, boolean state) {
+		if (state)
+			flags |= flag;
+		else
+			flags &= ~flag;
+	}
+
+	private void setState(int tokenType) {
+		state.token = null;
+		state.channel = Token.DEFAULT_CHANNEL;
+		state.tokenStartCharIndex = input.index();
+		state.tokenStartCharPositionInLine = input.getCharPositionInLine();
+		state.tokenStartLine = input.getLine();
+		state.text = null;
+		state.type = tokenType;
+	}
+
+	char next() {
+		return next(1);
+	}
+
+	char next(int i) {
+		return (char)input.LA(i);
+	}
+
+	void consumeUntilAny(String term) {
+		term += (char)CharStream.EOF;
+		while (term.indexOf(next()) == -1)
+			matchAny();
+	}
+
+	@Override
+	public Token nextToken() {
+		switch (previous.getType()) {
+		case RULE_HEADER_ID:
+			setState(RULE_HEADER_VALUE);
+			checkML();
+			mHEADER_VALUE();
+			return previous = emit();
+		case RULE_TYPE_HEADER:
+			checkML();
+			context = CTX_TYPE;
+			if (isSet(FLG_MULTILINE)) {
+				setState(RULE_WS);	// any ignored token
+				matchAny();	// consume '~'
+				return previous = emit();
+			}
+			break;
+		case RULE_WS:
+			if (context == CTX_TYPE_MIN) {
+				if (isSet(FLG_TYPE_IS_STRING)) {
+					if (!Character.isDigit(next()) && next() != '-') {	// if string length is omitted
+						if (isSet(FLG_MULTILINE))
+							matchAny();	// ignore expected '~'
+						setState(RULE_INT);
+						state.text = "0";	// pretend the max value is 0
+						return previous = emit();
+					}
+				}
+			}
+			if (previous.getText().indexOf('\n') != -1 ||
+					previous.getText().indexOf('\r') != -1) {
+				if (!isSet(FLG_MULTILINE)) {
+					context = CTX_NONE;
+				}
+				// workaround for '#include'
+				if (willMatch("#include")) {
+					setState(RULE_PROP_INCLUDE);
+					try {
+						mRULE_PROP_INCLUDE();
+					} catch (RecognitionException e) {
+						reportError(e);
+					}
+					return previous = emit();
+				}
+				if (!isSet(FLG_MULTILINE)) {
+					break;
+				}
+			}
+			if (context == CTX_TYPE_MAX) {
+				if (isSet(FLG_MULTILINE)) {
+					context = CTX_TYPE_DEFAULT;
+				} else {
+					context = CTX_NONE;
+				}
+				if (isSet(FLG_TYPE_IS_NUMERIC)) {
+					if (isSet(FLG_MULTILINE) && !Character.isDigit(next())
+							&& next() != '-') {	// if default value is omitted
+						previous = aux_ENUM_LITERAL();
+						if (previous != null)
+							return previous;
+					}
+					break;
+				} else {
+					setState(RULE_HEADER_VALUE);
+					mRULE_TYPE_HEADER_VALUE();
+					return previous = emit();
+				}
+			} else if (context == CTX_TYPE_DEFAULT) {
+				previous = aux_ENUM_LITERAL();
+				if (previous != null)
+					return previous;
+			}
+			break;
+		case RULE_ID:
+			if (context == CTX_TYPE) {
+				if ("df".indexOf(previous.getText().charAt(0)) == -1) {
+					setFlag(FLG_TYPE_IS_NUMERIC, false);
+					setFlag(FLG_TYPE_IS_STRING, previous.getText().charAt(0) == (int)'s');
+				} else {
+					setFlag(FLG_TYPE_IS_NUMERIC, true);
+				}
+				context = CTX_TYPE_ID;
+				break;
+			}
+			context = CTX_NONE;
+			break;
+		case RULE_HEADER_VALUE:
+		case RULE_ENUM_LITERAL:
+			if (context == CTX_TYPE_DEFAULT) {
+				previous = aux_ENUM_LITERAL();
+				if (previous != null)
+					return previous;
+			}
+			context = CTX_NONE;
+			break;
+		case RULE_DOUBLE:
+		case RULE_INT:
+			if (context == CTX_TYPE_DEFAULT) {
+				break;	// avoid changing context
+			} else if (context == CTX_TYPE_ID) {
+				context = CTX_TYPE_MIN;
+				break;
+			} else if (context == CTX_TYPE_MIN) {
+				context = CTX_TYPE_MAX;
+				break;
+			}
+			context = CTX_NONE;
+			break;
+		default:
+			if ("-".equals(previous.getText()) ||
+					"+".equals(previous.getText())) {
+				break;
+			}
+			context = CTX_NONE;
+		case RULE_SL_COMMENT:
+			break;
+		}
+		return previous = super.nextToken();
+	}
+
+	private boolean willMatch(String string) {
+		for (int i = 0; i < string.length(); ++i) {
+			if (next(i+1) != string.charAt(i))
+				return false;
+		}
+		return true;
+	}
+
+	private Token aux_ENUM_LITERAL() {
+		// CTX_TYPE_DEFAULT assumes raised FLG_MULTILINE
+		if (next() == '~') {
+			setState(RULE_WS);	// any ignored token
+			matchAny();
+			context = CTX_NONE;
+			return emit();
+		} else if (next() == '\\' && next(2) == '~') {
+			matchAny();	// not assigned to any terminal
+			setState(RULE_ENUM_LITERAL);
+			matchAny();	// consume '~'
+			mRULE_TYPE_HEADER_VALUE();
+			return emit();
+		}
+		return null;
+	}
+	
+	private void mRULE_TYPE_HEADER_VALUE() {
+		if (isSet(FLG_MULTILINE)) {
+			do {
+				consumeUntilAny("\\~");
+				if (next() == '\\' && next(2) != '~') {
+					matchAny();
+					continue;
+				}
+			} while (false);
+		} else {
+			consumeUntilAny("~\r\n");
+		}
+	}
+
+	private void mHEADER_VALUE() {
+		if (isSet(FLG_MULTILINE)) {
+			matchAny();	// consume '~'
+			do {
+				consumeUntilAny("\\~");
+				if (next() == '\\') {
+					matchAny();
+					if (next() == '~')
+						matchAny();
+					continue;
+				}
+			} while (false);
+			matchAny();
+		} else {
+			consumeUntilAny("\r\n");
+		}
+	}
+}
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptRuntimeModule.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptRuntimeModule.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptRuntimeModule.java	(revision 440)
@@ -16,8 +16,9 @@
 import com.framsticks.framclipse.script.context.Framscontext;
 import com.framsticks.framclipse.script.model.Framscript;
+import com.google.inject.Binder;
 import com.thoughtworks.xstream.XStream;
 
 /**
- * Use this class to register components to be used within the IDE.
+ * Use this class to register components to be used at runtime / without the Equinox extension registry.
  */
 public class FramScriptRuntimeModule extends com.framsticks.framclipse.AbstractFramScriptRuntimeModule {
@@ -56,3 +57,10 @@
 	}
 
+	@Override
+	public void configureRuntimeLexer(Binder binder) {
+		binder.bind(org.eclipse.xtext.parser.antlr.Lexer.class)
+                        .annotatedWith(com.google.inject.name.Names.named(org.eclipse.xtext.parser.antlr.LexerBindings.RUNTIME))
+                        .to(FramScriptAuxiliaryLexer.class);
+	}
+
 }
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptValueConverterService.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptValueConverterService.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/FramScriptValueConverterService.java	(revision 440)
@@ -18,13 +18,26 @@
 			protected String internalToValue(String s, INode node)
 					throws ValueConverterException {
-				if (s.startsWith(":~")) {
-					return s.substring(2, s.lastIndexOf('~')).trim();
-				} else {
-					return s.substring(1).trim();
+				String r = s;
+				if (s.startsWith("~")) {
+					r = s.substring(1, s.lastIndexOf('~'));
 				}
+				return r.trim().replaceAll("\\~", "~");
 			}
 
 		};
 	}
-	
+
+	@ValueConverter(rule = "ML_STRING")
+	public IValueConverter<String> ML_STRING() {
+
+		return new AbstractToStringConverter<String>() {
+
+			@Override
+			protected String internalToValue(String s, INode node)
+					throws ValueConverterException {
+				return s.substring(3, s.length()-3);
+			}
+
+		};
+	}
 }
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/GenerateFramScript.mwe2
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/GenerateFramScript.mwe2	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/GenerateFramScript.mwe2	(revision 440)
@@ -80,6 +80,6 @@
 			// Java-based API for validation
 			fragment = validation.JavaValidatorFragment auto-inject {
-			//	composedCheck = "org.eclipse.xtext.validation.ImportUriValidator"
-			//	composedCheck = "org.eclipse.xtext.validation.NamesAreUniqueValidator"
+				composedCheck = "org.eclipse.xtext.validation.ImportUriValidator"
+				composedCheck = "org.eclipse.xtext.validation.NamesAreUniqueValidator"
 			}
 
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/formatting/FramScriptFormatter.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/formatting/FramScriptFormatter.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/formatting/FramScriptFormatter.java	(revision 440)
@@ -17,22 +17,15 @@
 
 /**
- * This class contains custom formatting description.
+ * This class contains custom formatting declarations.
  * 
- * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#formatting
- * on how and when to use it
+ * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#formatting
+ * on how and when to use it.
  * 
- * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an
- * example
+ * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
  */
 public class FramScriptFormatter extends AbstractDeclarativeFormatter {
-	
-	@Override
-	protected FramScriptGrammarAccess getGrammarAccess() {
-		return (FramScriptGrammarAccess) super.getGrammarAccess();
-	}
-
 	@Override
 	protected void configureFormatting(FormattingConfig c) {
-		FramScriptGrammarAccess f = getGrammarAccess();
+		FramScriptGrammarAccess f = (FramScriptGrammarAccess) getGrammarAccess();
 		
 		//Headers
@@ -68,5 +61,5 @@
 		c.setNoSpace().before(f.getFlagsHeaderAccess().getIntValueAssignment_2());
 		
-		c.setNoSpace().after(f.getTypeHeaderAccess().getNameTypeKeyword_0_0());
+		c.setNoSpace().after(f.getTypeHeaderAccess().getNameTYPE_HEADERTerminalRuleCall_0_0());
 		c.setLinewrap().after(f.getTypeHeaderAccess().getTypeAssignment_1());
 		
@@ -94,9 +87,9 @@
 		// BlockIndentation
 		BlockElements block = f.getBlockAccess();
-		c.setIndentation(block.getLeftCurlyBracketKeyword_1(), 
-				block.getRightCurlyBracketKeyword_3());
-		c.setLinewrap().before(block.getLeftCurlyBracketKeyword_1());
-		c.setLinewrap().after(block.getLeftCurlyBracketKeyword_1());
-		c.setLinewrap().after(block.getRightCurlyBracketKeyword_3());
+		c.setIndentation(block.getLeftCurlyBracketKeyword_0(),
+				block.getRightCurlyBracketKeyword_2());
+		c.setLinewrap().before(block.getLeftCurlyBracketKeyword_0());
+		c.setLinewrap().after(block.getLeftCurlyBracketKeyword_0());
+		c.setLinewrap().after(block.getRightCurlyBracketKeyword_2());
 
 		// Param
@@ -104,5 +97,6 @@
 		c.setNoLinewrap().around(fullStop);
 		c.setNoSpace().around(fullStop);
-		c.setNoSpace().after(f.getPropertyAccessAccess().getAlternatives_0());
+		c.setNoSpace().after(f.getPropertyAccessAccess().getAlternatives_1());
+		c.setNoSpace().after(f.getPropertyAccessAccess().getAlternatives_2());
 		
 		// Invocation
@@ -117,7 +111,7 @@
 		
 		//Arrays
-		c.setNoSpace().after(f.getArrayAccess().getLeftSquareBracketKeyword_0());
+		c.setNoSpace().after(f.getArrayAccess().getLeftSquareBracketKeyword_1());
 		c.setNoSpace().before(f.getArrayAccess().getRightSquareBracketKeyword_3());
-		c.setNoSpace().before(f.getArrayAccess().getCommaKeyword_2_0());
+		c.setNoSpace().before(f.getArrayAccess().getCommaKeyword_2_1_0());
 		
 		// Unary expression
